// Veera Tic Tac Toe (v-ttt) - A game of Tic-Tac-Toe

// v-ttt.c 

/*

Copyright Notice:

Copyright (C) 2006, 2015 R Veera Kumar

This file is part of v-ttt.

v-ttt is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, version 3 of the License.

v-ttt is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with v-ttt.  If not, see <http://www.gnu.org/licenses/>.

See the COPYING file distributed together for license information.

See the AUTHOR file distributed together for authors information.

*/

#include "v-ttt.h"

#if V_SYSTEM == UNIX
struct termios vterm_org_attr, vterm_mod_attr;
struct sigaction new_action_tstp, old_action_tstp, new_action_cont, old_action_cont;
int v_sig_state = 0;
#endif

char m[3][3];

int main(void)
{
 signed short int cstep = 0,i;
 unsigned short int scr_ply = 0, scr_cmp = 0;
 char * ply;
 char player[20] = "Mickey", CMP_AI[] = "AI (Veera)";
 char status,mui,wchk_st, D = 'b', pui;
 char wchk_st2 = '0', muib = 'f', game = 'f', menu = 't', lstat = 'f', nstat = 'f';

#if V_SYSTEM == UNIX

 sigaction (SIGTSTP, NULL, &old_action_tstp);
 sigaction (SIGTSTP, NULL, &old_action_cont);
 new_action_tstp.sa_handler = v_sig_tstp;
 new_action_cont.sa_handler = v_sig_cont;

 sigaction (SIGTSTP, &new_action_tstp, NULL);
 sigaction (SIGCONT, &new_action_cont, NULL);

 vterm_init();
#endif

 ttt_menu();

 srand((unsigned int) time(0));  /* initialize seed */

while (1)
 {

  if (wchk_st2 != 'c') {
// Get input
  if (wchk_st2 != '0') {printf("\n %s\'s turn\n", player); printttt();}
  if (wchk_st2 == 'u') wchk_st2 = '1';

  while (lstat == 'f' ? muib != 't' && (status=ttt_m_ui(menu, wchk_st2)) != '1' : muib != 't')
   {
    if (lstat == 't') lstat = 'f';
    if (status == 'q') exit(EXIT_SUCCESS);
    else if (status == 'm')
     {
      ttt_menu();
      menu = 't';
     }
    else if (status == 'n')
     {
      puts(v_text_new_game);
      menu = 't';
      nstat = 't';
     }
    else if (status == 'u' && nstat == 't')
     {
      wchk_st2 = 'u';
      ttt_m_in();
      muib = 't';
      game = 't';
      menu = 'f';
      nstat = 'f';
      cstep = -1;     /* -1 because there is extra ++ cstep below without a play. */
      scr_ply = 0;
      scr_cmp = 0;
     }
    else if (status == 'c' && nstat == 't')
     {
      wchk_st2 = 'c';
      ttt_m_in();
      muib = 't';
      game = 't';
      menu = 'f';
      nstat = 'f';
      cstep = -1;     /* -1 because there is extra ++ cstep below without a play. */
      scr_ply = 0;
      scr_cmp = 0;
     }
    else if (status == 'h') { ttt_help(); menu = 't'; }
    else if (status == 'r' && game == 't') { printttt(); menu = 'f'; }
    else if (status == 'l') { ttt_license(); menu = 't'; }
    else if (status == 'a') { ttt_about(); menu = 't'; }
    else if (status == 'd' || status == 'b' || status == 'i' || status == 'e') {menu = 't'; if (status != 'd') D = status;
                         puts(v_text_diff);
                         fputs(" Beginner ",stdout);putchar('(');putchar(D == 'b' ? '*' : ' ');putchar(')');putchar('\t');fputs("Intermediate ",stdout);putchar('(');putchar(D == 'i' ? '*' : ' ');putchar(')');putchar('\t');fputs("Expert ",stdout);putchar('(');putchar(D == 'e' ? '*' : ' ');putchar(')');putchar('\n');
                        }
else if (status == 'p') {menu = 't';
                         puts("\n               Player Names");
                         puts("              ==============");
                         puts("\n       Computer AI: AI (Veera)");
                         printf("       Current Player Name: %s\n", player);
                        do {
                         fputs("\n       New Player Name: ",stdout);
#if V_SYSTEM == UNIX
vterm_end();
v_sig_state = 1;
#endif
                         ply = fgets(player, 20, stdin);
#if V_SYSTEM == UNIX
v_sig_state = 0;
tcsetattr(STDIN_FILENO, TCSAFLUSH, &vterm_mod_attr);
#endif
                         if (ply == NULL) puts("Error in input: Retry");
                           } while (ply == NULL);
                         i = strlen(player)-1;
                         if(player[i] == '\n') player[i] = '\0';
//                         while ((pui = getch()) != '\r' || pui != '\n');
                        }
else if (status == 's') {menu = 't';
                         puts(v_text_scores);
                         printf(" %s: %u\n", player, scr_ply);
                         printf(" AI (Veera): %u\n", scr_cmp);
                        }
else if (status == 't') {ttt_tips(); menu = 't';}
                                                }   /* End while loop */
}       /* End if block */
/* End input */

if (muib == 't') muib = 'f';
cstep = ++cstep;        /* Increment count of steps */

/* Start win chk */
if (wchk_st2 != 'u' && wchk_st2 != 'c')
{
if ((wchk_st = ttt_m_wchk(cstep, wchk_st2)) == '1') {
printttt();
printf("\n %s Wins!\n", player);
scr_ply = ++scr_ply;
printf(" Scores =>      %s: %u     %s: %u\n", player, scr_ply, CMP_AI, scr_cmp);
if (wchk_st2 == '2') wchk_st2 = 'u';
else if (wchk_st2 == '1') wchk_st2 = 'c';
ttt_m_in();
cstep = 0;
                                   }
else if (wchk_st == '3') {
printttt();
puts("\n Tie!\n");
printf(" Scores =>      %s: %u     %s: %u\n", player, scr_ply, CMP_AI, scr_cmp);
ttt_m_in();
if (wchk_st2 == '2') wchk_st2 = 'u';
else if (wchk_st2 == '1') wchk_st2 = 'c';
cstep = 0;
                        }
}
/* End win check. */

if (wchk_st2 != 'u') {             /* Start if block */
if (wchk_st2 == 'c') wchk_st2 = '2';

ttt_m_cpl(cstep, wchk_st2, D);    /* Cmp play */
cstep = ++cstep;
/* Start win chk */
if ((wchk_st = ttt_m_wchk(cstep, wchk_st2)) == '2') {
printttt();
printf("\n AI (Veera) Wins!\n");
scr_cmp = ++scr_cmp;
printf(" Scores =>      %s: %u     %s: %u\n", player, scr_ply, CMP_AI, scr_cmp);
if (wchk_st2 == '2') {wchk_st2 = 'u'; cstep = 0;}
else if (wchk_st2 == '1') {wchk_st2 = 'c'; cstep = -1;}
ttt_m_in();
                  }
else if (wchk_st == '3') {
printttt();
puts("\n Tie!\n");
printf(" Scores =>      %s: %u     %s: %u\n", player, scr_ply, CMP_AI, scr_cmp);
ttt_m_in();
if (wchk_st2 == '2') {wchk_st2 = 'u'; cstep = 0;}
else if (wchk_st2 == '1') {wchk_st2 = 'c'; cstep = -1;}
                       }
/* End win chk */
                     } /* End if block */
          } /* End of while loop */

 return 0;

} /* End main fn */


void printttt(void)
{
printf ("\n  %c | %c | %c \n",m[0][0],m[0][1],m[0][2]);
printf (" ---|---|---\n");
printf ("  %c | %c | %c \n",m[1][0],m[1][1],m[1][2]);
printf (" ---|---|---\n");
printf ("  %c | %c | %c \n",m[2][0],m[2][1],m[2][2]);

}

void ttt_m_in(void)
{
short int mlp1,mlp2;
char letter=' ';
for (mlp1=0;mlp1<3;mlp1++) {
for (mlp2=0;mlp2<3;mlp2++) m[mlp1][mlp2]=letter;
                           }

}

char ttt_m_ui(char menu, char wchk_st2)
{
char ui, M= 'a';

while (1) {
if (menu == 'f') {
        while ((ui = GETCH()) != 'h' && ui != 'H' && ui!= 'n' && ui!= 'N' && ui != 'm' && ui != 'M' && ui !='q' && ui != 'Q' && ui != '1' && ui != '2' && ui != '3' && ui != '4' && ui != '5' && ui != '6' && ui != '7' && ui != '8' && ui != '9' && ui != 'l' && ui != 'L' && ui != 'a' && ui != 'A' && ui != 'd' && ui != 'D' && ui != 'b' && ui != 'B' && ui != 'i' && ui != 'I' && ui != 'e' && ui != 'E' && ui != 'p' && ui != 'P' && ui != 's' && ui != 'S' && ui != 't' && ui != 'T');
        if (wchk_st2 == '1') M = 'O'; else if (wchk_st2 == '2') M = 'X';
                 }
else if (menu == 't')
        while ((ui = GETCH()) != 'h' && ui != 'H' && ui!= 'n' && ui!= 'N' && ui != 'r' && ui != 'R' && ui != 'm' && ui != 'M' && ui !='q' && ui != 'Q' && ui != 'u' && ui != 'U' && ui != 'c' && ui != 'C' && ui != 'l' && ui != 'L' && ui != 'a' && ui != 'A' && ui != 'd' && ui != 'D' && ui != 'b' && ui != 'B' && ui != 'i' && ui != 'I' && ui != 'e' && ui != 'E' && ui != 'p' && ui != 'P' && ui != 's' && ui != 'S' && ui != 't' && ui != 'T');
switch (ui) {
        case '7':
        if (m[0][0] == ' ')
        {m[0][0] = M; return '1';}
        break;
        
        case '8':
        if (m[0][1] == ' ')
        {m[0][1] = M; return '1';}
        break;

        case '9':
        if (m[0][2] == ' ')
        {m[0][2] = M; return '1';}
        break;

        case '4':
        if (m[1][0] == ' ')
        {m[1][0] = M; return '1';}
        break;

        case '5':
        if (m[1][1] == ' ')
        {m[1][1] = M; return '1';}
        break;

        case '6':
        if (m[1][2] == ' ')
        {m[1][2] = M; return '1';}
        break;

        case '1':
        if (m[2][0] == ' ')
        {m[2][0] = M; return '1';}
        break;

        case '2':
        if (m[2][1] == ' ')
        {m[2][1] = M; return '1';}
        break;

        case '3':
        if (m[2][2] == ' ')
        {m[2][2] = M; return '1';}
        break;

        case 'q':
        case 'Q':
        return 'q';

        case 'm':
        case 'M':
        return 'm';

        case 'h':
        case 'H':
        return 'h';

        case 'r':
        case 'R':
        return 'r';

        case 'n':
        case 'N':
        return 'n';

        case 'u':
        case 'U':
        return 'u';

        case 'c':
        case 'C':
        return 'c';

        case 'l':
        case 'L':
        return 'l';

        case 'a':
        case 'A':
        return 'a';

        case 'd':
        case 'D':
        return 'd';

        case 'b':
        case 'B':
        return 'b';

        case 'i':
        case 'I':
        return 'i';

        case 'e':
        case 'E':
        return 'e';

        case 'p':
        case 'P':
        return 'p';

        case 's':
        case 'S':
        return 's';

        case 't':
        case 'T':
        return 't';

                }
        }      
}

char ttt_m_wchk(signed short int cstep, char wchk_st2)
{
char U,C;
if (cstep >= 5) {
if (wchk_st2 == '1') {U = 'O'; C = 'X';} else if (wchk_st2 == '2') {C = 'O'; U = 'X';}

if(m[0][0] == m[0][1] && m[0][1] == m[0][2]) {
        if (m[0][0] == U)
        return '1';
        else if (m[0][0] == C)
        return '2';
                                             }

if(m[1][0] == m[1][1] && m[1][1] == m[1][2]) {
        if (m[1][0] == U)
        return '1';
        else if (m[1][0] == C)
        return '2';
                                             }

if(m[2][0] == m[2][1] && m[2][1] == m[2][2]) {
        if (m[2][0] == U)
        return '1';
        else if (m[2][0] == C)
        return '2';
                                             }

if(m[0][0] == m[1][0] && m[1][0] == m[2][0]) {
        if (m[0][0] == U)
        return '1';
        else if (m[0][0] == C)
        return '2';
                                             }

if(m[0][1] == m[1][1] && m[1][1] == m[2][1]) {
        if (m[0][1] == U)
        return '1';
        else if (m[0][1] == C)
        return '2';
                                             }

if(m[0][2] == m[1][2] && m[1][2] == m[2][2]) {
        if (m[0][2] == U)
        return '1';
        else if (m[0][2] == C)
        return '2';
                                             }

if(m[0][0] == m[1][1] && m[1][1] == m[2][2]) {
        if (m[0][0] == U)
        return '1';
        else if (m[0][0] == C)
        return '2';
                                             }

if(m[0][2] == m[1][1] && m[1][1] == m[2][0]) {
        if (m[0][2] == U)
        return '1';
        else if (m[0][2] == C)
        return '2';
                                             }

if (cstep == 9) return '3';
}       /* end cstep if block */
return '4';       /* To suppress compiler warning */
}

void ttt_m_cpl(signed short int cstep, char wchk_st2, char D)
{
int ttt_rand;
char tf_s='0', C, U, rf_ds, P;
char c[3][3];
signed short int i, j, n, rf_c, rf_d[5], rf_d2[5], rf_d3[5];

if (wchk_st2 == '1') {U = 'O'; C = 'X';} else if (wchk_st2 == '2') {C = 'O'; U = 'X';}

/* intermediate algo user first cstep == 1 sq !chk */
if (wchk_st2 == '1' && cstep == 1 && D != 'b') {

        /* 1st sq */
if (tf_s != '1' && m[1][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 7 && m[0][0] == ' ') { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 9 && m[0][2] == ' ') { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 1 && m[2][0] == ' ') { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 3 && m[2][2] == ' ') { m[2][2] = C; tf_s = '1'; }
                        }
                    }

        /* 2nd sq & 3rd sq */
if (tf_s != '1' && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 8) + 2;
        if (ttt_rand == 7 && m[0][0] == ' ') { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 9 && m[0][2] == ' ') { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 5 && m[1][1] == ' ') { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 2 && m[2][1] == ' ') { m[2][1] = C; tf_s = '1'; }
                        }
                    }

if (tf_s != '1' && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 7) + 1;
        if (ttt_rand == 7 && m[0][0] == ' ') { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 6 && m[1][2] == ' ') { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 5 && m[1][1] == ' ') { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1 && m[2][0] == ' ') { m[2][0] = C; tf_s = '1'; }
                        }
                    }

if (tf_s != '1' && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 8) + 1;
        if (ttt_rand == 8 && m[0][1] == ' ') { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 3 && m[2][2] == ' ') { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 5 && m[1][1] == ' ') { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1 && m[2][0] == ' ') { m[2][0] = C; tf_s = '1'; }
                        }
                    }

if (tf_s != '1' && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 7) + 3;
        if (ttt_rand == 9 && m[0][2] == ' ') { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 3 && m[2][2] == ' ') { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 5 && m[1][1] == ' ') { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 4 && m[1][0] == ' ') { m[1][0] = C; tf_s = '1'; }
                        }
                    }

        /* 4th, 5th, 6th & 7th sq */
if (tf_s != '1' && m[0][0] == U) { m[1][1] = C; tf_s = '1'; }
if (tf_s != '1' && m[2][0] == U) { m[1][1] = C; tf_s = '1'; }
if (tf_s != '1' && m[2][2] == U) { m[1][1] = C; tf_s = '1'; }
if (tf_s != '1' && m[0][2] == U) { m[1][1] = C; tf_s = '1'; }

}       /* end intermediate algo user first if block */

/* intermediate algo cmp play first */

if (wchk_st2 == '2' && cstep == 2 && D != 'b') {

        /* 1st case - no addn algo req but req to must win */

if (tf_s != '1' && m[1][1] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                 }

if (tf_s != '1' && m[1][1] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 8) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                 }

if (tf_s != '1' && m[1][1] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                 }

if (tf_s != '1' && m[1][1] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 8) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                 }

        /* 2nd case - addn algo req to must win */

if (tf_s != '1' && m[0][1] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 5;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[0][1] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 3) + 5;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[1][0] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 1;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[1][0] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 3) + 5;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[2][1] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 3) + 3;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[2][1] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 1;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[1][2] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 3) + 3;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                 }

if (tf_s != '1' && m[1][2] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 5;
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
                        }
                                                 }

        /* 3rd case - No addn algo req */

if (tf_s != '1' && m[0][1] == C && m[2][0] == U) { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == C && m[2][2] == U) { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == C && m[0][2] == U) { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == C && m[2][2] == U) { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][1] == C && m[0][0] == U) { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][1] == C && m[0][2] == U) { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][2] == C && m[0][0] == U) { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][2] == C && m[2][0] == U) { m[2][2] = C; tf_s='1'; }

        /* 4th case - addn algo req to must win */

if (tf_s != '1' && m[0][0] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 1;
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[0][0] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 5;
        if (ttt_rand == 8) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 4) + 4;
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 4) + 2;
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 1;
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 5;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 4) + 5;
        if (ttt_rand == 8) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 3) + 3;
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                  }

        /* 5th case - no addn algo req but req to must win */

if (tf_s != '1' && m[0][0] == C && m[0][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 4) + 1;
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[0][0] == C && m[2][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 7) + 3;
        if (ttt_rand == 8) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } 
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[0][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 8) + 2;
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } /* rem to ensure must win */
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[2][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 6) + 4;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 4) { m[1][0] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[2][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[0][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 7) + 1;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 2) { m[2][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[0][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 6) + 1;
        if (ttt_rand == 6) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } /* rem to ensure must win */
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[2][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 8) + 1;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 8) { m[0][1] = C; tf_s = '1'; }
                        }
                                                  }

        /* 6th case - no addn algo req but req to must win */

if (tf_s != '1' && m[0][0] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[0][0] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[1][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[0][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; } /* rem to ensure must win */
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[2][1] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[1][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; } /* rem to ensure must win */
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
        if (ttt_rand == 5) { m[1][1] = C; tf_s = '1'; }
                        }
                                                  }

        /* 7th case - no addn algo req but req to must win */

if (tf_s != '1' && m[0][0] == C && m[2][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][0] == C && m[0][2] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[2][2] == C && m[0][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 9) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 1) { m[2][0] = C; tf_s = '1'; }
                        }
                                                  }

if (tf_s != '1' && m[0][2] == C && m[2][0] == U) {
while (tf_s != '1')     {
ttt_rand = (rand() % 5) + 3;
        if (ttt_rand == 7) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 3) { m[2][2] = C; tf_s = '1'; }
                        }
                                                  }

}       /* end intermediate algo cmp play first */

/* Triple fill */
if ((wchk_st2 == '2' && cstep > 3) || (wchk_st2 == '1' && cstep > 4) && tf_s != '1') {

if (m[0][0] == m[0][1] && m[0][0] == C && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[0][2] && m[0][1] == C && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[0][2] && m[0][0] == C && m[0][1] == ' ') { m[0][1] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[1][1] && m[1][0] == C && m[1][2] == ' ') { m[1][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[1][2] && m[1][1] == C && m[1][0] == ' ') { m[1][0] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[1][2] && m[1][0] == C && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[2][1] && m[2][0] == C && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[2][1] == m[2][2] && m[2][1] == C && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[2][2] && m[2][0] == C && m[2][1] == ' ') { m[2][1] = C; tf_s='1'; }

if (tf_s != '1' && m[0][0] == m[1][0] && m[0][0] == C && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[2][0] && m[1][0] == C && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[2][0] && m[0][0] == C && m[1][0] == ' ') { m[1][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[1][1] && m[0][1] == C && m[2][1] == ' ') { m[2][1] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[2][1] && m[1][1] == C && m[0][1] == ' ') { m[0][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[2][1] && m[0][1] == C && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[1][2] && m[0][2] == C && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][2] == m[2][2] && m[1][2] == C && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[2][2] && m[0][2] == C && m[1][2] == ' ') { m[1][2] = C; tf_s='1'; }

if (tf_s != '1' && m[0][0] == m[1][1] && m[0][0] == C && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[2][2] && m[1][1] == C && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[2][2] && m[0][0] == C && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[1][1] && m[0][2] == C && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[1][1] && m[2][0] == C && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[2][0] && m[0][2] == C && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
}       /* end trp fill */

/* Triple prevent */
if ((wchk_st2 == '2' && cstep > 3) || (wchk_st2 == '1' && cstep > 2) && tf_s != '1') {
if (m[0][0] == m[0][1] && m[0][0] == U && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[0][2] && m[0][1] == U && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[0][2] && m[0][0] == U && m[0][1] == ' ') { m[0][1] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[1][1] && m[1][0] == U && m[1][2] == ' ') { m[1][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[1][2] && m[1][1] == U && m[1][0] == ' ') { m[1][0] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[1][2] && m[1][0] == U && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[2][1] && m[2][0] == U && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[2][1] == m[2][2] && m[2][1] == U && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[2][2] && m[2][0] == U && m[2][1] == ' ') { m[2][1] = C; tf_s='1'; }

if (tf_s != '1' && m[0][0] == m[1][0] && m[0][0] == U && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[1][0] == m[2][0] && m[1][0] == U && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[2][0] && m[0][0] == U && m[1][0] == ' ') { m[1][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[1][1] && m[0][1] == U && m[2][1] == ' ') { m[2][1] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[2][1] && m[1][1] == U && m[0][1] == ' ') { m[0][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][1] == m[2][1] && m[0][1] == U && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[1][2] && m[0][2] == U && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][2] == m[2][2] && m[1][2] == U && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[2][2] && m[0][2] == U && m[1][2] == ' ') { m[1][2] = C; tf_s='1'; }

if (tf_s != '1' && m[0][0] == m[1][1] && m[0][0] == U && m[2][2] == ' ') { m[2][2] = C; tf_s='1'; }
if (tf_s != '1' && m[1][1] == m[2][2] && m[1][1] == U && m[0][0] == ' ') { m[0][0] = C; tf_s='1'; }
if (tf_s != '1' && m[0][0] == m[2][2] && m[0][0] == U && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[1][1] && m[0][2] == U && m[2][0] == ' ') { m[2][0] = C; tf_s='1'; }
if (tf_s != '1' && m[2][0] == m[1][1] && m[2][0] == U && m[0][2] == ' ') { m[0][2] = C; tf_s='1'; }
if (tf_s != '1' && m[0][2] == m[2][0] && m[0][2] == U && m[1][1] == ' ') { m[1][1] = C; tf_s='1'; }
}       /* end trp prevent */

/* prv 2clk sq - expert algo */
if (tf_s != '1' && D == 'e' && ((wchk_st2 == '2' && cstep > 3 && cstep !=9) || (wchk_st2 == '1' && cstep > 2 && cstep != 8))) {

P = U;

        /* find !2clk sq  & 2clk sq */
for (i=0;i<5;i++) {
rf_d[i] = 0;
                  }

for (i=0;i<5;i++) {
rf_d2[i] = 0;
                  }

for (i=0;i<3;i++){
 for (j=0;j<3;j++) {

        c[0][0] = m[0][0];c[0][1] = m[0][1];c[0][2] = m[0][2];
        c[1][0] = m[1][0];c[1][1] = m[1][1];c[1][2] = m[1][2];
        c[2][0] = m[2][0];c[2][1] = m[2][1];c[2][2] = m[2][2];

        if (c[i][j] == ' ') {

        c[i][j] = P;
        rf_c = 0;

                /* horz */
if (c[0][0] == c[0][1] && c[0][0] == P && c[0][2] == ' ') ++rf_c;
if (c[0][0] == c[0][2] && c[0][0] == P && c[0][1] == ' ') ++rf_c;
if (c[0][1] == c[0][2] && c[0][1] == P && c[0][0] == ' ') ++rf_c;
if (c[1][0] == c[1][1] && c[1][0] == P && c[1][2] == ' ') ++rf_c;
if (c[1][0] == c[1][2] && c[1][0] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[1][2] && c[1][1] == P && c[1][0] == ' ') ++rf_c;
if (c[2][0] == c[2][1] && c[2][0] == P && c[2][2] == ' ') ++rf_c;
if (c[2][0] == c[2][2] && c[2][0] == P && c[2][1] == ' ') ++rf_c;
if (c[2][1] == c[2][2] && c[2][1] == P && c[2][0] == ' ') ++rf_c;

                /* vert */

if (c[0][0] == c[1][0] && c[0][0] == P && c[2][0] == ' ') ++rf_c;
if (c[0][0] == c[2][0] && c[0][0] == P && c[1][0] == ' ') ++rf_c;
if (c[2][0] == c[1][0] && c[2][0] == P && c[0][0] == ' ') ++rf_c;
if (c[0][1] == c[1][1] && c[0][1] == P && c[2][1] == ' ') ++rf_c;
if (c[0][1] == c[2][1] && c[0][1] == P && c[1][1] == ' ') ++rf_c;
if (c[2][1] == c[1][1] && c[2][1] == P && c[0][1] == ' ') ++rf_c;
if (c[0][2] == c[1][2] && c[0][2] == P && c[2][2] == ' ') ++rf_c;
if (c[0][2] == c[2][2] && c[0][2] == P && c[1][2] == ' ') ++rf_c;
if (c[2][2] == c[1][2] && c[2][2] == P && c[0][2] == ' ') ++rf_c;

                /* diag */
if (c[0][0] == c[1][1] && c[0][0] == P && c[2][2] == ' ') ++rf_c;
if (c[0][0] == c[2][2] && c[0][0] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[2][2] && c[1][1] == P && c[0][0] == ' ') ++rf_c;
if (c[0][2] == c[1][1] && c[0][2] == P && c[2][0] == ' ') ++rf_c;
if (c[0][2] == c[2][0] && c[0][2] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[2][0] && c[1][1] == P && c[0][2] == ' ') ++rf_c;

        if (rf_c == 1) { 
                        for (n = 0, rf_ds = 'f';rf_ds != 't' && n < 5; n++) {
                if (rf_d[n] == 0) {
                if (i == 0 && j == 0) {rf_d[n] = 7; rf_ds = 't';}
                else if (i == 0 && j == 1) {rf_d[n] = 8; rf_ds = 't';}
                else if (i == 0 && j == 2) {rf_d[n] = 9; rf_ds = 't';}
                else if (i == 1 && j == 0) {rf_d[n] = 4; rf_ds = 't';}
                else if (i == 1 && j == 1) {rf_d[n] = 5; rf_ds = 't';}
                else if (i == 1 && j == 2) {rf_d[n] = 6; rf_ds = 't';}
                else if (i == 2 && j == 0) {rf_d[n] = 1; rf_ds = 't';}
                else if (i == 2 && j == 1) {rf_d[n] = 2; rf_ds = 't';}
                else if (i == 2 && j == 2) {rf_d[n] = 3; rf_ds = 't';}
                                    }
                                                                            }
                      }

        if (rf_c > 1) { 
                        for (n = 0, rf_ds = 'f';rf_ds != 't' && n < 5; n++) {
                if (rf_d2[n] == 0) {
                if (i == 0 && j == 0) {rf_d2[n] = 7; rf_ds = 't';}
                else if (i == 0 && j == 1) {rf_d2[n] = 8; rf_ds = 't';}
                else if (i == 0 && j == 2) {rf_d2[n] = 9; rf_ds = 't';}
                else if (i == 1 && j == 0) {rf_d2[n] = 4; rf_ds = 't';}
                else if (i == 1 && j == 1) {rf_d2[n] = 5; rf_ds = 't';}
                else if (i == 1 && j == 2) {rf_d2[n] = 6; rf_ds = 't';}
                else if (i == 2 && j == 0) {rf_d2[n] = 1; rf_ds = 't';}
                else if (i == 2 && j == 1) {rf_d2[n] = 2; rf_ds = 't';}
                else if (i == 2 && j == 2) {rf_d2[n] = 3; rf_ds = 't';}
                                    }
                                                                            }
                      }


                }
 }
}

        /* force fill up of !2clk sq */
for (i=0;i<5;i++) {
rf_d3[i] = 0;
                  }

for (i=0;i<5 && rf_d[i] != 0;i++) {
        c[0][0] = m[0][0];c[0][1] = m[0][1];c[0][2] = m[0][2];
        c[1][0] = m[1][0];c[1][1] = m[1][1];c[1][2] = m[1][2];
        c[2][0] = m[2][0];c[2][1] = m[2][1];c[2][2] = m[2][2];

P = C;

if (rf_d[i] == 7) {c[0][0] = C;}
if (rf_d[i] == 8) {c[0][1] = C;}
if (rf_d[i] == 9) {c[0][2] = C;}
if (rf_d[i] == 4) {c[1][0] = C;}
if (rf_d[i] == 5) {c[1][1] = C;}
if (rf_d[i] == 6) {c[1][2] = C;}
if (rf_d[i] == 1) {c[2][0] = C;}
if (rf_d[i] == 2) {c[2][1] = C;}
if (rf_d[i] == 3) {c[2][2] = C;}

                /* horz */
if (c[0][0] == c[0][1] && c[0][0] == P && c[0][2] == ' ') cpl_rf_d3(9, rf_d3);
if (c[0][0] == c[0][2] && c[0][0] == P && c[0][1] == ' ') cpl_rf_d3(8, rf_d3);
if (c[0][1] == c[0][2] && c[0][1] == P && c[0][0] == ' ') cpl_rf_d3(7, rf_d3);
if (c[1][0] == c[1][1] && c[1][0] == P && c[1][2] == ' ') cpl_rf_d3(6, rf_d3);
if (c[1][0] == c[1][2] && c[1][0] == P && c[1][1] == ' ') cpl_rf_d3(5, rf_d3);
if (c[1][1] == c[1][2] && c[1][1] == P && c[1][0] == ' ') cpl_rf_d3(4, rf_d3);
if (c[2][0] == c[2][1] && c[2][0] == P && c[2][2] == ' ') cpl_rf_d3(3, rf_d3);
if (c[2][0] == c[2][2] && c[2][0] == P && c[2][1] == ' ') cpl_rf_d3(2, rf_d3);
if (c[2][1] == c[2][2] && c[2][1] == P && c[2][0] == ' ') cpl_rf_d3(1, rf_d3);

                /* vert */

if (c[0][0] == c[1][0] && c[0][0] == P && c[2][0] == ' ') cpl_rf_d3(1, rf_d3);
if (c[0][0] == c[2][0] && c[0][0] == P && c[1][0] == ' ') cpl_rf_d3(4, rf_d3);
if (c[2][0] == c[1][0] && c[2][0] == P && c[0][0] == ' ') cpl_rf_d3(7, rf_d3);
if (c[0][1] == c[1][1] && c[0][1] == P && c[2][1] == ' ') cpl_rf_d3(2, rf_d3);
if (c[0][1] == c[2][1] && c[0][1] == P && c[1][1] == ' ') cpl_rf_d3(5, rf_d3);
if (c[2][1] == c[1][1] && c[2][1] == P && c[0][1] == ' ') cpl_rf_d3(8, rf_d3);
if (c[0][2] == c[1][2] && c[0][2] == P && c[2][2] == ' ') cpl_rf_d3(3, rf_d3);
if (c[0][2] == c[2][2] && c[0][2] == P && c[1][2] == ' ') cpl_rf_d3(6, rf_d3);
if (c[2][2] == c[1][2] && c[2][2] == P && c[0][2] == ' ') cpl_rf_d3(9, rf_d3);

                /* diag */
if (c[0][0] == c[1][1] && c[0][0] == P && c[2][2] == ' ') cpl_rf_d3(3, rf_d3);
if (c[0][0] == c[2][2] && c[0][0] == P && c[1][1] == ' ') cpl_rf_d3(5, rf_d3);
if (c[1][1] == c[2][2] && c[1][1] == P && c[0][0] == ' ') cpl_rf_d3(7, rf_d3);
if (c[0][2] == c[1][1] && c[0][2] == P && c[2][0] == ' ') cpl_rf_d3(1, rf_d3);
if (c[0][2] == c[2][0] && c[0][2] == P && c[1][1] == ' ') cpl_rf_d3(5, rf_d3);
if (c[1][1] == c[2][0] && c[1][1] == P && c[0][2] == ' ') cpl_rf_d3(9, rf_d3);
                                                                                                      }

while (tf_s != '1' && rf_d3[0] != 0)     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 7 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 8 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 9 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 4 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 5 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 6 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 2 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 3 && (ttt_rand == rf_d3[0] || ttt_rand == rf_d3[1] || ttt_rand == rf_d3[2] || ttt_rand == rf_d3[3] || ttt_rand == rf_d3[4])) { m[2][2] = C; tf_s = '1'; }
                                        }

        /* chk 2clk sq */
while (tf_s != '1' && rf_d2[0] != 0)     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 7 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 8 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 9 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 4 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 5 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 6 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 2 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 3 && (ttt_rand == rf_d2[0] || ttt_rand == rf_d2[1] || ttt_rand == rf_d2[2] || ttt_rand == rf_d2[3] || ttt_rand == rf_d2[4])) { m[2][2] = C; tf_s = '1'; }
                                        }

}       /* end prv 2clk sq - expert algo */

/* 2clk sq fill - part of intermediate algo */

if (tf_s != '1' && ((wchk_st2 == '2' && cstep == 4 && D == 'i') || (wchk_st2 == '2' && cstep >= 4 && cstep != 9 && D == 'e') || (wchk_st2 == '1' && cstep >= 5 && cstep != 8 && D == 'e'))) {
P = C;
for (i=0;i<5;i++) {
rf_d[i] = 0;
                  }

for (i=0;i<3;i++){
 for (j=0;j<3;j++) {

        c[0][0] = m[0][0];c[0][1] = m[0][1];c[0][2] = m[0][2];
        c[1][0] = m[1][0];c[1][1] = m[1][1];c[1][2] = m[1][2];
        c[2][0] = m[2][0];c[2][1] = m[2][1];c[2][2] = m[2][2];

        if (c[i][j] == ' ') {

        c[i][j] = P;
        rf_c = 0;

                /* horz */
if (c[0][0] == c[0][1] && c[0][0] == P && c[0][2] == ' ') ++rf_c;
if (c[0][0] == c[0][2] && c[0][0] == P && c[0][1] == ' ') ++rf_c;
if (c[0][1] == c[0][2] && c[0][1] == P && c[0][0] == ' ') ++rf_c;
if (c[1][0] == c[1][1] && c[1][0] == P && c[1][2] == ' ') ++rf_c;
if (c[1][0] == c[1][2] && c[1][0] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[1][2] && c[1][1] == P && c[1][0] == ' ') ++rf_c;
if (c[2][0] == c[2][1] && c[2][0] == P && c[2][2] == ' ') ++rf_c;
if (c[2][0] == c[2][2] && c[2][0] == P && c[2][1] == ' ') ++rf_c;
if (c[2][1] == c[2][2] && c[2][1] == P && c[2][0] == ' ') ++rf_c;

                /* vert */

if (c[0][0] == c[1][0] && c[0][0] == P && c[2][0] == ' ') ++rf_c;
if (c[0][0] == c[2][0] && c[0][0] == P && c[1][0] == ' ') ++rf_c;
if (c[2][0] == c[1][0] && c[2][0] == P && c[0][0] == ' ') ++rf_c;
if (c[0][1] == c[1][1] && c[0][1] == P && c[2][1] == ' ') ++rf_c;
if (c[0][1] == c[2][1] && c[0][1] == P && c[1][1] == ' ') ++rf_c;
if (c[2][1] == c[1][1] && c[2][1] == P && c[0][1] == ' ') ++rf_c;
if (c[0][2] == c[1][2] && c[0][2] == P && c[2][2] == ' ') ++rf_c;
if (c[0][2] == c[2][2] && c[0][2] == P && c[1][2] == ' ') ++rf_c;
if (c[2][2] == c[1][2] && c[2][2] == P && c[0][2] == ' ') ++rf_c;

                /* diag */
if (c[0][0] == c[1][1] && c[0][0] == P && c[2][2] == ' ') ++rf_c;
if (c[0][0] == c[2][2] && c[0][0] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[2][2] && c[1][1] == P && c[0][0] == ' ') ++rf_c;
if (c[0][2] == c[1][1] && c[0][2] == P && c[2][0] == ' ') ++rf_c;
if (c[0][2] == c[2][0] && c[0][2] == P && c[1][1] == ' ') ++rf_c;
if (c[1][1] == c[2][0] && c[1][1] == P && c[0][2] == ' ') ++rf_c;

        if (rf_c > 1) { 
                        for (n = 0, rf_ds = 'f';rf_ds != 't' && n < 5; n++) {
                if (rf_d[n] == 0) {
                if (i == 0 && j == 0) {rf_d[n] = 7; rf_ds = 't';}
                else if (i == 0 && j == 1) {rf_d[n] = 8; rf_ds = 't';}
                else if (i == 0 && j == 2) {rf_d[n] = 9; rf_ds = 't';}
                else if (i == 1 && j == 0) {rf_d[n] = 4; rf_ds = 't';}
                else if (i == 1 && j == 1) {rf_d[n] = 5; rf_ds = 't';}
                else if (i == 1 && j == 2) {rf_d[n] = 6; rf_ds = 't';}
                else if (i == 2 && j == 0) {rf_d[n] = 1; rf_ds = 't';}
                else if (i == 2 && j == 1) {rf_d[n] = 2; rf_ds = 't';}
                else if (i == 2 && j == 2) {rf_d[n] = 3; rf_ds = 't';}
                                    }
                                                                            }
                      }
                }
 }
}

while (tf_s != '1' && rf_d[0] != 0)     {
ttt_rand = (rand() % 9) + 1;
        if (ttt_rand == 7 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[0][0] = C; tf_s = '1'; }
        if (ttt_rand == 8 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[0][1] = C; tf_s = '1'; }
        if (ttt_rand == 9 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[0][2] = C; tf_s = '1'; }
        if (ttt_rand == 4 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[1][0] = C; tf_s = '1'; }
        if (ttt_rand == 5 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[1][1] = C; tf_s = '1'; }
        if (ttt_rand == 6 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[1][2] = C; tf_s = '1'; }
        if (ttt_rand == 1 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[2][0] = C; tf_s = '1'; }
        if (ttt_rand == 2 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[2][1] = C; tf_s = '1'; }
        if (ttt_rand == 3 && (ttt_rand == rf_d[0] || ttt_rand == rf_d[1] || ttt_rand == rf_d[2] || ttt_rand == rf_d[3] || ttt_rand == rf_d[4])) { m[2][2] = C; tf_s = '1'; }
                        }

}       /* end 2clk sq fill - part of intermediate algo */

/* Random fill */
while (tf_s != '1') {

ttt_rand = (rand() % 9) + 1;
switch (ttt_rand) {
        case 7:
        if (m[0][0] == ' ') { m[0][0] = C; tf_s = '1'; }
        break;

        case 8:
        if (m[0][1] == ' ') { m[0][1] = C; tf_s = '1'; }
        break;

        case 9:
        if (m[0][2] == ' ') { m[0][2] = C; tf_s = '1'; }
        break;

        case 4:
        if (m[1][0] == ' ') { m[1][0] = C; tf_s = '1'; }
        break;

        case 5:
        if (m[1][1] == ' ') { m[1][1] = C; tf_s = '1'; }
        break;

        case 6:
        if (m[1][2] == ' ') { m[1][2] = C; tf_s = '1'; }
        break;

        case 1:
        if (m[2][0] == ' ') { m[2][0] = C; tf_s = '1'; }
        break;

        case 2:
        if (m[2][1] == ' ') { m[2][1] = C; tf_s = '1'; }
        break;

        case 3:
        if (m[2][2] == ' ') { m[2][2] = C; tf_s = '1'; }
        break;

              }
                }       /* end rnd fill while loop */
 

} /* End function */

void cpl_rf_d3(signed short int mn, signed short int * rf_d)
 {
  char rf_ds;
  signed short int n;
 
  for (n = 0, rf_ds = 'f';rf_ds != 't' && n < 5; n++)
   {
    if (rf_d[n] == 0)
     {
      if (mn == 7) { rf_d[n] = 7; rf_ds = 't'; }
      else if (mn == 8) { rf_d[n] = 8; rf_ds = 't'; }
      else if (mn == 9) { rf_d[n] = 9; rf_ds = 't'; }
      else if (mn == 4) { rf_d[n] = 4; rf_ds = 't'; }
      else if (mn == 5) { rf_d[n] = 5; rf_ds = 't'; }
      else if (mn == 6) { rf_d[n] = 6; rf_ds = 't'; }
      else if (mn == 1) { rf_d[n] = 1; rf_ds = 't'; }
      else if (mn == 2) { rf_d[n] = 2; rf_ds = 't'; }
      else if (mn == 3) { rf_d[n] = 3; rf_ds = 't'; }
     }
   }
 }

void ttt_menu(void)
{
puts (v_text_menu);
}

void ttt_help(void)
 {
  puts (v_text_help);
 }

void ttt_tips(void)
 {
  puts(v_text_tips);
 }

void ttt_license(void)
 {
  puts(v_text_license);
 } 

void ttt_about(void)
 {
  puts(v_text_about);
 }

#if V_SYSTEM == UNIX
void vterm_end (void)
 {
  tcsetattr (STDIN_FILENO, TCSANOW, &vterm_org_attr);
 }

void vterm_init (void)
 {

  if(!isatty (STDIN_FILENO))
   {
    fprintf(stderr, "Not a terminal.\n");
    exit(EXIT_FAILURE);
   }

  tcgetattr(STDIN_FILENO, &vterm_org_attr);
  atexit(vterm_end);

  tcgetattr(STDIN_FILENO, &vterm_mod_attr);
  vterm_mod_attr.c_lflag &= ~(ICANON|ECHO);
  vterm_mod_attr.c_cc[VMIN] = 1;
  vterm_mod_attr.c_cc[VTIME] = 0;
  tcsetattr(STDIN_FILENO, TCSAFLUSH, &vterm_mod_attr);

 }

void v_sig_tstp (int sig)
 {
  vterm_end();
  sigaction (sig, &old_action_tstp, NULL);
  raise(sig);
 }

void v_sig_cont (int sig)
 {
  if (v_sig_state == 0) tcsetattr(STDIN_FILENO, TCSAFLUSH, &vterm_mod_attr);
  else tcsetattr (STDIN_FILENO, TCSANOW, &vterm_org_attr);
  sigaction (SIGTSTP, &new_action_tstp, NULL);
 }

#endif
